﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Custom View class
#Event: Loaded
#Event: CodeChanged(Change As Object)
'V1.1
'	Added change font size
'	Added hide line numbes
'	Fixed issue in CodeMirror library where it was not possible to select text with the mouse.
'		'CodeMirror Library patched as per - https://github.com/codemirror/CodeMirror/issues/5733
'
'V1.2
'	changed HTML template For better loading And consistency.
'	Implemented encodebase64 For text transfer
'	now a proper wrapper, all required calls are in the CodeEditorWrapper
'	improved syntax highlighting
'
'V1.3
'	Added most of the available languages
'	Added b4x.js to the proper structure within CodeMirror mode folder and Meta.js
'	Added new code module to Map App Names to mime types
'	Added and implemented autoLoad addon to select language by MimeType
'	Changes to the CodeMirror library - requires downloading new version
'
'V1.4
'	Added doc.clearHistory to setCode to stop undo removing the new code
'	Added #javacompilerpath to ide parameter words.
'	requires download of codemirrorlib
'	Moved the InitializeFiles sub to the WebCodeEditor class where it belongs.

'V1.5
'	Separated from the CodeEditor module for easier minimal implementation.
'	Added ReadOnly option
'	Added Themes
'		Requires an allowedthemes List to be passed so they can be validataed against the defined themes.
'		you can pass a subset of the defined themes so only your preferred themes are available.

'V.1.51
'Small process changes to enable minimal implementation
'	Please download library / Project from the dropbox link
'	Added minimal implementation example.

'V1.52
'	Fixed readOnly bug
'	Added LineWrapping
'	Added Autofocus
'	Removed dependency on JScriptEngine
'	Added highlighting for B4s

Private Sub Class_Globals
	
	Private fx As JFX
	Private XUI As XUI
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView
	Public WebView1 As WebView
	Public WebE As WebEngine
	Type B4xCallsType(module As Object, EventName As String)
	Private B4xCalls As Map
	
	'Wrapper variables
	Private MimeType, CurrentTheme,mByFileType As String
	Private mAllowedThemes As List
	Private mCodeMirrorPath As String
	Private mFontSize As Int = 12
	Private mFontUnit As String = "pt"
	Private mShowLineNumbers As String = "true"
	Private mLineWrapping As String = "false"
	Private mReadOnly As String = "false"
	Private mAutofocus As String = "false"
	Private Loaded As Boolean
	Private mWidth As Int
	Private mHeight As Int
	Private Code As String
	Public Tag As Object

End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	CMW_Utils.Initialize						'initialize lookup maps
	mCodeMirrorPath = InitializeFiles
	mAllowedThemes.Initialize
End Sub

'Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
Private Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Tag = mBase.Tag
	
	'Initial Values
	mWidth = mBase.Width
	mHeight = mBase.Height

	mBase.LoadLayout("codemirrorwrapper")
	
	mBase.Tag = Me
	WebE = WebEngine_Static.New(WebView1)
	
	WebE.SetOnAlert(Me,"JSAlert")
	WebE.SetOnError(Me,"JSError")
	
	B4xCalls.Initialize
	RegisterB4XCall("JsLog",Me,"Js_Log")
	RegisterB4XCall("codechanged",mCallBack,mEventName & "_CodeChanged")
	
	WebE.AddWorkerListener(Me,"LoadProgress")

End Sub

Private Sub LoadProgress_Event (NewState As String)
	Log("State: " & NewState)
	
	If NewState  = "SUCCEEDED" Then  ' <<<<<< NEVER RETURN SUCCEEDED, ONLY SCHEDULED, RUNNING, CANCELLED
		Log("Page LOADED")
		' Setup the javascript interface
		Set_Bridge
		Sleep(0)
		Loaded = True
		Dim Su As StringUtils
		ExecuteScript($"setCode("${Su.EncodeBase64(Code.GetBytes("UTF8"))}");"$)
		If mByFileType <> "" Then
			ExecuteScript($"changeType("${mByFileType}")"$)
		Else If MimeType <> "" Then
			ExecuteScript($"changeType("${MimeType}")"$)
		End If
		If CurrentTheme <> "" Then ExecuteScript($"editor.setOption("theme", "${CurrentTheme}");"$)
		If mReadOnly <> "false" Then ExecuteScript($"editor.setOption("readOnly", ${mReadOnly});"$)
		If mLineWrapping <> "false" Then ExecuteScript($"editor.setOption("lineWrapping", ${mLineWrapping});"$)
		If mAutofocus <> "false" Then ExecuteScript($"editor.setOption("autofocus", ${mAutofocus});"$)
		SetSize(mWidth + 10, mHeight + 10)
		CallSub(mCallBack,mEventName & "_Loaded")
	End If
End Sub


Private Sub Base_Resize (Width As Double, Height As Double)
	SetSize(Width,Height)
End Sub

Public Sub GetBase As B4XView
	Return mBase
End Sub

'###############################################################################
#Region JS interface subs
'###############################################################################

'Register a Javascript callback and map it to the required B4xSub
Sub RegisterB4XCall(CallName As String,Module As Object,EventName As String)
	Dim B4xCall As B4xCallsType
	B4xCall.Initialize
	B4xCall.Module = Module
	B4xCall.EventName = EventName
	B4xCalls.Put(CallName,B4xCall)
End Sub

'Call a registered sub with no parameters
Sub CallB4x(CallName As String) As Object		'Ignore
	Dim B4xCall As B4xCallsType = B4xCalls.Get(CallName)
	If B4xCall = Null Then
		Log("B4xCall " & CallName & " not registered")
		Return Null
	End If
	If SubExists(B4xCall.Module,B4xCall.EventName) Then
		Return CallSub(B4xCall.Module,B4xCall.EventName)
	Else
		Log("Sub " & B4xCall.EventName & " Not found")
		Return Null
	End If
End Sub

'Call a registered sub with 1 parameter
Sub CallB4x2(CallName As String, Param1 As Object) As Object	'ignore
	Dim B4xCall As B4xCallsType = B4xCalls.Get(CallName)
'	Log(B4xCall)
	If B4xCall = Null Then
		Log("B4xCall " & CallName & " not registered")
		Return Null
	End If
	If SubExists(B4xCall.Module,B4xCall.EventName) Then
		Return CallSub2(B4xCall.Module,B4xCall.EventName,Param1)
	Else
		Log("Sub " & B4xCall.EventName & " Not found")
		Return Null
	End If
	
End Sub

'Call a registered sub with 2 parameters
Sub CallB4x3(CallName As String,Param1 As Object,Param2 As Object) As Object	'Ignore
	Dim B4xCall As B4xCallsType = B4xCalls.Get(CallName)
	If B4xCall = Null Then
		Log("B4xCall " & CallName & " not registered")
		Return Null
	End If
	If SubExists(B4xCall.Module,B4xCall.EventName) Then
		Return CallSub3(B4xCall.Module,B4xCall.EventName,Param1,Param2)
	Else
		Log("Sub " & B4xCall.EventName & " Not found")
		Return Null
	End If
End Sub

'Capture Javascript events
Private Sub JSAlert_Event(Args() As Object)
	Dim Msg As String
	If GetType(Args(0)) = "javafx.scene.web.WebErrorEvent" Then
		Msg = ASJO(Args(0)).RunMethod("getMessage",Null)
	Else
		Msg = ASJO(Args(0)).RunMethod("getData",Null)
	End If
'	If Msg = "done" Then RunJS("alert(window.b4j)")
	Log("JSALERT : **************************************************************")
	Log("JSALERT : " & Msg)
	Log("JSALERT : **************************************************************")
'	If Msg = "done" Then Log(getHTMLText)
End Sub

Private Sub JSError_Event(Args() As Object)
	Dim Msg As String
	If GetType(Args(0)) = "javafx.scene.web.WebErrorEvent" Then
		Msg = ASJO(Args(0)).RunMethod("getMessage",Null)
	Else
		Msg = ASJO(Args(0)).RunMethod("getData",Null)
	End If
	Log("JSError : **************************************************************")
	Log("JSError : " & Msg)
	Log("JSError : **************************************************************")
End Sub

'Receiving calls from JS console.log
Private Sub Js_Log(text As Object)
	Log("JS console.log: " & text)
End Sub

'Call java code to setup the JS Bridge
Private Sub Set_Bridge
	Dim MeJo As JavaObject = Me
	MeJo.RunMethod("setBridge",Array(WebE.GetObject))
End Sub

#End Region JS Interface subs


#Region Wrapper Subs

Public Sub InitializeFiles As String
	
	Dim FVM As FileVersionManager
	FVM.Initialize
	
	FVM.ReadMaps(XUI.DefaultFolder,"version.txt",File.DirAssets,"version.txt")

	FVM.ReadItems("codemirror")
	Dim CodeMirrorPath As String = FVM.CurrentRelativePath
	
	If  FVM.DoUpdate Then
		Log("Updating codemirror library")
		File.Copy(File.DirAssets,"codemirror.zip",XUI.DefaultFolder,"codemirror.zip")
		Dim Arc As Archiver
		Dim Count As Int = Arc.UnZip(XUI.DefaultFolder,"codemirror.zip",XUI.DefaultFolder,"")
		Log(Count & " Files unzipped")
		File.Delete(XUI.DefaultFolder,"codemirror.zip")
		
		If FVM.DeletePreviousPath Then
			If FVM.DeleteFolder(FVM.DeleteFolder(FVM.PreviousRelativePath)) Then
				Log("Previous codemirror library removed " & FVM.PreviousRelativePath)
			End If
		End If
	End If
	
	FVM.ReadItems("wrapperjs")
	If  FVM.DoUpdate Then
		Log("Updating wrapper.js")
		File.Copy(File.DirAssets,"wrapper.js",XUI.DefaultFolder,"wrapper.js")
	End If
	
	'Currently empty, but required when changing highlight colours
	'Only update if does not exists, users may change this
	If File.Exists(XUI.DefaultFolder,"wrapper.css") = False Then
		File.Copy(File.DirAssets,"wrapper.css",XUI.DefaultFolder,"wrapper.css")
	End If
	
	'File versioning
	File.Copy(File.DirAssets,"version.txt",XUI.DefaultFolder,"version.txt")
	
	Return CodeMirrorPath
End Sub

Private Sub ASJO(JO As JavaObject) As JavaObject
	Return JO
End Sub

Public Sub Load(URL As String)
	Loaded = False
	WebE.Load(URL)
End Sub

'Get the current code editor code.
Public Sub GetCode As String
	Return ExecuteScript("editor.getValue();")
End Sub

Public Sub GetSelectedCode As String
	Return ExecuteScript("editor.getSelection();")
End Sub

Public Sub SetSize(Width As Double, Height As Double)
	mWidth = Width - 10
	mHeight = Height - 10
	If Loaded = False Then Return
	ExecuteScript($"editor.setSize(${mWidth},${mHeight})"$)
End Sub

Public Sub ReadOnly(State As Boolean,ShowCursor As Boolean)
	If State = False Then
		mReadOnly = $"false"$
	Else
		If ShowCursor Then
			mReadOnly  = $"true"$
		Else
			mReadOnly = $""nocursor""$
		End If
	End If
	Log("Mr " & mReadOnly)
	If Loaded Then ExecuteScript($"editor.setOption("readOnly", ${mReadOnly});"$)
End Sub

public Sub SetFontSize(FontSize As Int, FontUnit As String)
	mFontSize = FontSize
	mFontUnit = FontUnit
	If Loaded = False Then Return
	ExecuteScript($"editor.getWrapperElement().style["font-size"] = ${mFontSize}+"${mFontUnit}";editor.refresh();"$)
End Sub

Public Sub ShowLineNos(ShowLineNumbers As Boolean)
	Dim Show As String = "false"
	If ShowLineNumbers Then Show = "true"
	mShowLineNumbers = Show
	If Loaded = False Then Return
	ExecuteScript($"editor.setOption("lineNumbers", ${Show});"$)
End Sub

'Get / Set the Language for this CodeMirror, 
'A full list of available Languages is available by calling <code>CMW_Utls.Languages</code>
'or viewing it's code.
Public Sub setLanguage(Language As String)
	Dim MT As String = CMW_Utils.MimeType(Language)
	If MT = "" Then
		Dim TH As Throwables
		TH.Initialize
		TH.Throw(Throwables_Static.NewIllegalArgumentException($"CodeMirrorWrapper : Language '${Language}' is not a valid Language.  Languages are case sensitive"$))
		Return
	End If
	MimeType = MT
	mByFileType = ""
	If Loaded Then ExecuteScript($"changeType("${MimeType}")"$)
End Sub

Public Sub SetLanguageByFileType(FileName As String)
	mByFileType = FileName
	If Loaded Then ExecuteScript($"changeType("${mByFileType}")"$)
End Sub

'Set the allowed themes for this codemirror.
'Get a full list of all defined themes using:
'<code>CMW_Utils.GetThemes</code>
'or viewing it's code. Themes are all lower cased
Public Sub SetAllowedThemes(Themes As List)
	For Each S As String In Themes
		If CMW_Utils.Themes.IndexOf(S) = -1 Then
			Dim TH As Throwables
			TH.Initialize
			TH.Throw(Throwables_Static.NewIllegalArgumentException($"CodeMirrorWrapper : AllowedTheme '${S}' is not a valid theme.  Themes are case sensitive"$))
			Return
		End If
	Next
	mAllowedThemes.AddAll(Themes)
End Sub

'Get / Set a theme for this codemirror
'Themes are all lowercased and must be in the AllowedThemes List
Public Sub setTheme(Theme As String)
	If mAllowedThemes.IndexOf(Theme) = -1 Then 
		Dim TH As Throwables
		TH.Initialize
		TH.Throw(Throwables_Static.NewIllegalArgumentException($"CodeMirrorWrapper : Theme '${Theme}' is not a valid theme"$))
		Return
	End If
	CurrentTheme = Theme
	If Loaded Then
		ExecuteScript($"editor.setOption("theme", "${CurrentTheme}");"$)
	End If
End Sub

Public Sub getTheme As String
	Return CurrentTheme
End Sub

Public Sub SetCode(NewCode As String)
	Code = NewCode
	'Delete the HTML for the last style used.
	If File.Exists(XUI.DefaultFolder,"codemirrorwrapper.HTML") Then
		File.Delete(XUI.DefaultFolder,"codemirrorwrapper.HTML")
	End If
	UpdatePage
End Sub

Public Sub setLineWrapping(State As Boolean)
	If State Then
		mLineWrapping = "true"
	Else
		mLineWrapping = "false"
	End If
	If Loaded Then ExecuteScript($"editor.setOption("lineWrapping", ${mLineWrapping});"$)
End Sub

Public Sub setAutoFocus(State As Boolean)
	If State Then
		mAutofocus = "true"
	Else
		mAutofocus = "false"
	End If
	If Loaded Then ExecuteScript($"editor.setOption("autofocus", ${mAutofocus});"$)
End Sub

private Sub UpdatePage
	CreateEditingTemplateFile
	Loaded = False
	Load(File.GetUri(XUI.DefaultFolder,"codemirrorwrapper.HTML"))
End Sub

'Replace the {code} tag with the actual code we want to edit.
'Private Sub applyEditingTemplate(Code As String) As String
'	Return EditingTemplate.Replace("{code}",Code) & CRLF
'End Sub


'Write the template to the application folder (easier than writing to temp while debugging).
Private Sub CreateEditingTemplateFile
	Dim Template As String = EditingTemplate
	File.WriteString(XUI.DefaultFolder,"codemirrorwrapper.HTML",Template)
End Sub

'Create an HTML file from the template with the links to the specified language mode.
Private Sub EditingTemplate As String


	Dim CSSFileURI As String = $"${mCodeMirrorPath}/lib/codemirror.css"$
	Dim CodeFileURI As String = $"${mCodeMirrorPath}/lib/codemirror.js"$
	Dim LoadModePath As String =  $"${mCodeMirrorPath}/addon/mode/loadmode.js"$
	Dim MatchBrackesPath As String = $"${mCodeMirrorPath}/addon/mode/matchbrackets.js"$
	Dim MetaPath As String =  $"${mCodeMirrorPath}/mode/meta.js"$
	Dim ModeURL As String =   $"${mCodeMirrorPath}/mode/%N/%N.js"$
	
	
	'Create imports

	Dim SB As StringBuilder
	SB.Initialize

	SB.Append($" <link rel="stylesheet" href="${CSSFileURI}" />
	<link rel="stylesheet" href="wrapper.css" />
	<script src="${CodeFileURI}"></script>
	<script src="${LoadModePath}"></script>
	<script src="${MatchBrackesPath}"></script>
	<script src="${MetaPath}"></script>
	<script src="wrapper.js"></script>"$)
	
	For Each S As String In mAllowedThemes
		If S = "default" Then Continue
		SB.Append(CRLF)
		SB.Append($"<link rel="stylesheet" href="${mCodeMirrorPath}/theme/${S}.css"</link>"$)
	Next

	Dim Imports As String = SB.ToString
	Return $"
<!doctype html
<html>
  <head>
  ${Imports}
   <style>
   		body{
   			overflow:hidden;
   		}
   		.CodeMirror{
			width: ${mWidth}px;
			height: ${mHeight}px;
			font-size: ${mFontSize}${mFontUnit};
		}
   </style>
  </head>
 <body>
 </body>
   <script>
   	var doc;
   	CodeMirror.modeURL = "${ModeURL}";
    var editor = CodeMirror(document.body, {
        lineNumbers: ${mShowLineNumbers},
        matchBrackets: true,
		indentUnit: 4
      });
	  //Set event For callback To B4j when the Code changes
	  editor.on('change',function(cm, change){
		  	callB4j("codechanged",change.text);
			//console.log("call commented");
	  });
	  function setCode(Code){
		editor.setValue(atob(Code));
		doc = editor.getDoc();
		doc.clearHistory();
	  }
	  
	function changeType(val){
		var mode,spec,m;
		if (m = /.+\.([^.]+)$/.exec(val)) {
	    	var info = CodeMirror.findModeByExtension(m[1]);
	    	if (info) {
	      		mode = info.mode;
	      		spec = info.mime;
	    	}
  		} else if (/\//.test(val)) {
    		var info = CodeMirror.findModeByMIME(val);
    		if (info) {
      		mode = info.mode;
      		spec = val;
    	}
  	} else {
    	mode = spec = val;
  	}
  	if (mode) {
    	editor.setOption("mode", spec);
    	CodeMirror.autoLoadMode(editor, mode);
  	} else {
    	console.log("Could not find a mode corresponding to " + val);
  	}
  }
	  
    </script>

</html>"$
End Sub

#End Region Wrapper Subs

'###############################################################################
#Region JS Functions
'###############################################################################

'Execute a Javascript.
Public Sub ExecuteScript(Script As String) As Object
	Return WebE.ExecuteScript(Script)
End Sub
'###############################################################################
#End Region JS Functions

#Region java
'Java
#if java
import netscape.javascript.JSObject;
import javafx.scene.web.WebEngine;
import anywheresoftware.b4a.BA.RaisesSynchronousEvents;

//Needs to be a global variable otherwise it appears to be garbage collected.
Bridge b;

public class Bridge{
    public Object callB4j(String sub,String funct) { // for call with no parameters
		return ba.raiseEvent2(this, false,sub.toLowerCase(),true, funct);
	}
    public Object callB4j2(String sub,String funct, Object arg) { // for call with  1 param
		return ba.raiseEvent2(this, false, sub.toLowerCase() , true, funct, arg);
	}
	public Object callB4j3(String sub, String funct,Object arg1, Object arg2) { // for call with  2 params
		return ba.raiseEvent2(this, false,sub.toLowerCase() ,true, funct,arg1 ,arg2);
	}
}
public void setBridge(WebEngine we) {
	
	JSObject jsobj = (JSObject) we.executeScript("window");
	b = new Bridge();
	jsobj.setMember("b4j", b);
	
	}
#end if

#End Region java
